import {
  getAdded,
  getUpdated,
  getViewAll,
  getByGroupID,
  getByName,
  save,
  refreshUpdate,
  parseData
} from './lib/Item'

import * as CONSTANT from './lib/constants.js'
const admin = require('firebase-admin')


export function  connect(host) {
let conn
    try {
      if (host) {
        admin.initializeApp({
        credential: admin.credential.applicationDefault(),
        databaseURL: host
        });
        conn = admin.database()
      }
    } catch (e) {
      console.log(e)
      throw e
    }

return {
  Item: {
    getAdded: function () {
      return getAdded(conn)()
    },
    getUpdated: function () {
      return getUpdated(conn)()
    },
    getViewAll: function (type) {
      return getViewAll(conn)(type)
    },
    getByGroupID: function (id) {
      return getByGroupID(conn)(id)
    },
    getByName: function (title, platform, searchType) {
      return getByName(conn)(title, platform, searchType)
    },
    save: function (store, itemMap, dataMap, removeMap) {
      return save(conn)(store, itemMap, dataMap, removeMap)
    },
    refreshUpdate: function () {
      return refreshUpdate(conn)()
    },
    parseData: function (item) {
      return parseData(conn)(item)
    }
  },
  CONSTANTS: CONSTANT
}

}


// const url = `mongodb://${host}:${port}`
//
// let client
//
// export const connect = async () => {
//   try {
//     if (!client) {
//       debug(`Connecting to ${url}`)
//       client = await MongoClient.connect(url, { poolSize })
//       debug('Connected')
//     }
//   } catch (e) {
//     debug(e)
//     throw e
//   }
//
//   const db = client.db(dbName)
//
//   return {
//     Item: {
//       save: saveItem(db),
//       get: getItem(db),
//       list: listItems(db),
//       check
//     },
//     User: {
//       save: saveUser(db),
//       get: getUser(db),
//       list: listUsers(db)
//     },
//     UserItem: {
//       add: addUserItem(db),
//       get: getUserItem(db),
//       update: updateUserItem(db),
//       list: listUserItems(db),
//       remove: removeUserItem(db)
//     }
//   }
//}
